/***********************************************************/
/*                                                         */
/* D3DStruct.h                                             */
/*                                                         */
/* created 25.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef D3DSTRUCT_H
#define D3DSTRUCT_H

#include "D3DStructures.h"
#include "Speed.h"

// www.infinitecode.com 3d library
namespace I3D
{

class D3DStruct
{
	// copying is not allowed
	D3DStruct(D3DStruct&);
	operator = (D3DStruct&);

public:
	LPDIRECT3DDEVICE8 D3DDevice;
	Matrix ViewMtx, ProjMtx, ProjViewMtx;
	ITL::Speed *Sp;

	D3DStruct(void) {}

	void Create(LPDIRECT3DDEVICE8 D3DDevice, ITL::Speed *Sp);
	void CreateProjViewMtx(void);
};

}

#endif
