/***********************************************************/
/*                                                         */
/* Game.h                                                  */
/*                                                         */
/* created 13.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef GAME_H
#define GAME_H

#include "D3DWindow.h"
#include "D3DStruct.h"
#include "World.h"
#include "EventListener.h"
#include "DynamicArray.h"
#include "MouseCursor.h"
#include "Speed.h"
#include "PhysicsStruct.h"

// Tank 4
namespace T4
{

enum
{
	// flags
	GAME_D3DFLAG_WIREFRAME = 1,
};

class Game: public IEV::EventListener<I3D::D3DWEvent>
{
	I3D::D3DWindow Wnd;
	I3D::D3DStruct DS;
	// the game world
	IGAME::World Wrld;
	int D3DFlags;
	I3D::MouseCursor Mouse;
	ITL::Speed Sp;
	bool AsyncReady;

	ISL::DynamicArray<I3D::D3DWEvent, 0, 4> Events;

	virtual void OnEvent(I3D::D3DWEvent Data);
	void EventHandler(void);
	void KeyboardHandler(char c);
	void MouseHandler(void);
	void Scrolling(void);
	void Init3D(void);
	void LoadingScreen(void);

public:
	Game(void)
		:AsyncReady(false), D3DFlags(0)
	{
	}

	~Game(void)
	{
		ShowCursor(true);
		AsyncReady = false;
	}

	void Create(int WindowStyle);
	// this is called continuously while the application is running
	void MainLoop(void);
};

}

#endif
