/***********************************************************/
/*                                                         */
/* ISLString.cpp                                           */
/*                                                         */
/* created 07.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "ISLString.h"
#include "IMath.h"

#include <string.h>

// www.infinitecode.com Standard Data Structure Library
namespace ISL
{

String::String(const char *Str)
{
	if(Str)
	{
		String::Str = new char[strlen(Str) + 1];
		strcpy(String::Str, Str);
	}
	else
	{
		String::Str = new char[1];
		strcpy(String::Str, "");
	}
}

String::String(void)
{
	String::Str = new char[1];
	strcpy(String::Str, "");
}

String::~String(void)
{
	delete[] Str;
}

int String::Length(void)
{
	return strlen(Str);
}

const char *String::GetChars(void)
{
	return Str;
}

void String::ReAlloc(int Size)
{
	char *New = new char[Size];
	memset(New, 0, Size);
	memcpy(New, Str, minf(Length() + 1, Size));
	char *Old = Str;
	Str = New;
	delete[] Old;
}

bool String::Replace(char *Str, char *Rep)
{
	char *In = strstr(String::Str, Str);
	if(In)
	{
		char *Post = In + strlen(Rep);
		String SPost = String(Post);
		*In = 0;
		String SPre = String(Str);
		String SIn = String(Rep);
		*this = SPre + SIn + SPost;
		return true;
	}
	return false;
}

}
