/***********************************************************/
/*                                                         */
/* IniLoader.h                                             */
/*                                                         */
/* created 05.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef INILOADER_H
#define INILOADER_H

#include "DynamicArray.h"
#include "MultiHashTable.h"
#include "ISLString.h"

// www.infinitecode.com tool library
namespace ITL
{

class IniLoader
{
	class Group
	{
		Create(const char *Name);
	public:
		char *Name;
		ISL::MultiHashTable<ISL::String, ISL::String, 0, 1, 0, 1> Table;

		Group(void);
		Group(const char *Name);
		~Group(void);

		// copy functions
		Group(Group& Gr)
		{
			*this = Gr;
		}

		operator = (Group& Gr)
		{
			Create(Gr.Name);
			Table = Gr.Table;
		}

		void Add(const char *Key, const char *Value);
	};

	ISL::DynamicArray<Group, 0, 1> Groups;

public:
	IniLoader(const char *FileName);

	const char *GetValue(const char *Group, const char *Key);
	const char *GetKey(const char *Group, int Num);

	int CountGroups(void);
	int CountKeys(const char *Group);
};

}

#endif
