/***********************************************************/
/*                                                         */
/* LogFile.h                                               */
/*                                                         */
/* created 14.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef LOGFILE_H
#define LOGFILE_H

#include <stdio.h>

// www.infinitecode.com tool library
namespace ITL
{

class LogFile
{
public:

	// delete the log file
	static void LogFile::Clear(char *FileName)
	{
		FILE *f = fopen(FileName, "wt");
		fclose(f);
	}

	// write a string into the log file
	static void LogFile::Msg(char *FileName, char *Message)
	{
		FILE *f = fopen(FileName, "at");
		fprintf(f, "%s\n", Message);
		fclose(f);
	}

	// write an int value into the log file
	static void LogFile::Msg(char *FileName, int Value)
	{
		FILE *f = fopen(FileName, "at");
		fprintf(f, "%d\n", Value);
		fclose(f);
	}

	// write a float value into the log file
	static void LogFile::Msg(char *FileName, float Value)
	{
		FILE *f = fopen(FileName, "at");
		fprintf(f, "%f\n", Value);
		fclose(f);
	}

};

}

#endif
