/***********************************************************/
/*                                                         */
/* Game.h                                                  */
/*                                                         */
/* created 13.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef GAME_H
#define GAME_H

#include "D3DWindow.h"
#include "D3DStruct.h"
#include "EventListener.h"
#include "DynamicArray.h"
#include "Model.h"
#include "RenderableModel.h"
#include "Input.h"

// www.infinitecode.com 3d library
namespace I3D
{

enum
{
	GAME_D3DFLAG_WIREFRAME = 1,
	GAME_D3DFLAG_NOCULLING = 2,
	GAME_D3DFLAG_COLORKEY = 4,
	GAME_D3DFLAG_ALPHABLEND = 8
};

class ModelEditor: public IEV::EventListener<I3D::D3DWEvent>
{
	D3DWindow Wnd;
	D3DStruct DS;
	int D3DFlags;
	Model *Mdl;
	LPDIRECT3DTEXTURE8 Texture;
	HINSTANCE Instance;
	char ModelFile[1024], TextureFile[1024];
	float Angle, Angle2;
	IIN::Input In;

	ISL::DynamicArray<I3D::D3DWEvent, 0, 4> Events;

	virtual void OnEvent(I3D::D3DWEvent Data);
	void EventHandler(void);
	void KeyboardInput(char c);
	void MouseClick(void);
	void Init3D(void);
	void MenuCheck(int ID);

public:
	ModelEditor(void)
		:D3DFlags(0)
	{
	}

	~ModelEditor(void)
	{
	}

	void Create(HINSTANCE ThisInstance, int WindowStyle);
	// this is called continuously while the application is running
	void MainLoop(void);
};

}

#endif
