/***********************************************************/
/*                                                         */
/* NURBS.h                                                 */
/*                                                         */
/* created 21.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

// NURBS surface based on a 256x256 Heightmap

#ifndef NURBS_H
#define NURBS_H

#include "D3DStructures.h"

// www.infinitecode.com 3d library
namespace I3D
{

class NURBS
{
	int XRes, ZRes;
	float Size;
	// hide HeightMap so 256 may be changed later easily
	float *HeightMap;

public:
	NURBS(void);
	~NURBS(void);

	float GetY(float x, float z);
	Vector GetNormal(float x, float z);
	void Create(int XRes, int ZRes, float Size);
};

}

#endif
