/***********************************************************/
/*                                                         */
/* RenderableModel.cpp                                     */
/*                                                         */
/* created 20.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "RenderableModel.h"

// www.infinitecode.com 3d library
namespace I3D
{

RenderableModel::RenderableModel(void)
:Texture(0), Mdl(0), Mtx(0), Pos(0, 0, 0), Data(0)
{
}

void RenderableModel::Render(D3DStruct *DS)
{
	if(Mdl)
	{
		if(Mtx)
			DS->D3DDevice->SetTransform(D3DTS_WORLD, Mtx);
		DS->D3DDevice->SetTexture(0, Texture);
		Mdl->Render(DS);
	}
}

}
