/***********************************************************/
/*                                                         */
/* RenderableModel.h                                       */
/*                                                         */
/* created 20.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef RENDERABLEMODEL_H
#define RENDERABLEMODEL_H

#include "Renderable.h"
#include "Model.h"

#include <d3d8.h>

// www.infinitecode.com 3d library
namespace I3D
{

class RenderableModel: public Renderable
{
	// data for managers etc, for example quadtree management
	void *Data;

protected:
	RenderableModel(void);

	virtual void CreateView(D3DStruct *DS) {}

public:
	LPDIRECT3DTEXTURE8 Texture;
	Model *Mdl;
	D3DMATRIX *Mtx;
	Vector Pos;

	virtual void Render(D3DStruct *DS);

	// data for managers etc, for example quadtree management
	void SetData(void *Data)
	{
		RenderableModel::Data = Data;
	}

	// data for managers etc, for example quadtree management
	void *GetData(void)
	{
		return Data;
	}
};

}

#endif
