/***********************************************************/
/*                                                         */
/* ServerSocket.h                                          */
/*                                                         */
/* created 03.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef SERVERSOCKET_H
#define SERVERSOCKET_H

#include "TCPSocket.h"
#include "ClientSocket.h"

#include <exception>

// www.infinitecode.com Network Library
namespace INETW
{

DWORD WINAPI SSThreadProcedure(void *Parameter);

class ServerSocket: public TCPSocket
{
	// socket handle
	int CSck;
	bool Blocking;
	struct sockaddr_in Adr;
	HANDLE ThreadHandle;
	unsigned long ThreadId;
	bool ThreadRunning;

	friend DWORD WINAPI SSThreadProcedure(void *Parameter);

	bool Create(char *Host, int Port, bool Blocking = true);

public:
	ServerSocket(char *Host, int Port, bool Blocking = true);
	~ServerSocket(void);

	virtual void Destroy(void);

	ClientSocket *Accept(bool Blocking = true);
};

}

#endif
