/***********************************************************/
/*                                                         */
/* Speed.cpp                                               */
/*                                                         */
/* created 27.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "Speed.h"

#include <time.h>

// www.infinitecode.com tool library
namespace ITL
{

Speed::Speed(void)
{
	Delta = 1 / 30.0f;
	DeltaLongTerm = 1 / 30.0f;
}

void Speed::Update(void)
{
	static float Time1 = ((float)clock()) / CLOCKS_PER_SEC;
	float Time2;
	// get current time in seconds
	Time2 = ((float)clock()) / CLOCKS_PER_SEC;
	// calculate speed constant
	Delta = 0.9f * Delta + 0.1f * (Time2 - Time1);
	DeltaLongTerm = 0.99f * DeltaLongTerm + 0.01f * (Time2 - Time1);
	if(Paused) Delta = 0;
	// don't let the speed below 5 fps, so the game is still playable on very slow computers (but with reduced speed)
	if(Delta > 1.0f / 5.0f) Delta = 1.0f / 5.0f;
	// calculate game time
	if(!Paused) GameTime += Delta;
	// remember the time for the next calculation
	Time1 = Time2;
}

}
