/***********************************************************/
/*                                                         */
/* Tank.h                                                  */
/*                                                         */
/* created 27.08.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TANK_H
#define TANK_H

#include "Actor.h"
#include "MathStructures.h"

// www.infinitecode.com game library
namespace IGAME
{

class Tank: public Actor
{
	IMATH::Vector2DXZ Target;
	int AIOrder;
	float LastShot;

public:
	virtual void Create(ActorSpecs *Specs);
	virtual void Physics(I3D::D3DStruct *DS);
	virtual void SetTargetPos(IMATH::Vector2DXZ Target);
	void MoveTo(IMATH::Vector2DXZ Target);
};

}

#endif
