/***********************************************************/
/*                                                         */
/* Tank4.cpp                                               */
/*                                                         */
/* created 12.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "Tank4.h"

#include "Game.h"

#define WIN32_LEAN_AND_MEAN // don't include rarely used header parts
#include <windows.h>
#include <stdlib.h>

// Tank 4
namespace T4
{

	Game T4;

}

int WINAPI WinMain(HINSTANCE ThisInstance, HINSTANCE PrevInstance, LPSTR Argument, int WindowStyle)
{
	try
	{
		T4::T4.Create(WindowStyle);
		bool Quit = false;
		MSG Msg;
		// main message handling loop
		while ( !Quit )
		{
			if ( PeekMessage( &Msg, NULL, 0, 0, PM_REMOVE ) )
			{
				if ( Msg.message == WM_QUIT )
				{
					Quit=TRUE;
				}
				else
				{
					TranslateMessage( &Msg );
					DispatchMessage( &Msg );
				}
			}
			else
			{
				// Game main loop function
				T4::T4.MainLoop();
			}
		}
	}
	catch(exception& Ex)
	{
		// exceptions
		char Str[1024];
		strcpy(Str, "Unhandled Exception: ");
		strcat(Str, (char *)Ex.what());
		ITL::LogFile::Msg("Error.txt", Str);
		ITL::MessageWindow::Message(Str, "Unhandled Exception");
		return -1;
	}
	catch(char *Ex)
	{
		// char * exceptions
		char Str[1024];
		strcpy(Str, "Unhandled Exception (char *): ");
		strcat(Str, Ex);
		ITL::LogFile::Msg("Error.txt", Str);
		ITL::MessageWindow::Message(Str, "Unhandled Exception");
		return -1;
	}
	catch(int Ex)
	{
		// int exceptions
		char Str[1024], Buf[1024];
		strcpy(Str, "Unhandled Exception (int): ");
		strcat(Str, itoa(Ex, Buf, 10));
		ITL::LogFile::Msg("Error.txt", Str);
		ITL::MessageWindow::Message(Str, "Unhandled Exception");
		return -1;
	}
	catch(...)
	{
		// unknown exceptions
		ITL::LogFile::Msg("Error.txt", "Unhandled Unknown Exception");
		ITL::MessageWindow::Message("Unknown Exception", "Unhandled Exception");
		return -1;
	}
	return 0;
}
