/***********************************************************/
/*                                                         */
/* Terrain.cpp                                             */
/*                                                         */
/* created 16.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#include "Terrain.h"

#include "TextureManager.h"

// www.infinitecode.com 3d library
namespace I3D
{

void Terrain::Create(D3DStruct DS, float Size)
{
	// create surface
	Surface.Create(256, 256, Size);
	For.Create(DS, BoundingBox2D(-0.5f * Size, 0.5f * Size, -0.5f * Size, 0.5f * Size), &Surface);
}

void Terrain::Render(D3DStruct DS)
{
	Renderable::Render(DS);
	DS.TM->SetTexture(0, NULL);
	//For.InvalidateView();
	RenderObjects(DS);
}

void Terrain::CreateView(D3DStruct DS)
{
	For.OnViewChange();
}

void Terrain::RenderObjects(D3DStruct DS)
{
	For.Render(DS);
}

}
