/***********************************************************/
/*                                                         */
/* Tree.h                                                  */
/*                                                         */
/* created 16.07.2002                                      */
/* by Christian Reimann  empgodot@gmx.de                   */
/*                                                         */
/* Copyright    Christian Reimann                          */
/*              empgodot@gmx.de                            */
/*              www.infinitecode.com                       */
/*                                                         */
/* This code may be freely modified and redistributed.     */
/* If you use parts of this code in a project,             */
/* I'd appreciate a mention in the credits.                */
/*                                                         */
/***********************************************************/

#ifndef TREE_H
#define TREE_H

#include "RenderableModel.h"
#include "MathStructures.h"
#include "Model.h"
#include "QuadTree.h"
#include "Actor.h"

// www.infinitecode.com game library
namespace IGAME
{

struct TreeSpecs
{
	I3D::D3DStruct *DS;
	IMATH::Vector Pos;
	I3D::QuadTree *QT;
};

class Tree: public Actor
{
public:
	~Tree(void);

	virtual void Create(ActorSpecs *Specs);
	virtual void Physics(I3D::D3DStruct *DS);
	virtual void SetTargetPos(IMATH::Vector2DXZ Target);
};

// ****** TreeModel ******

class TreeModel: public I3D::Model
{

	/*operator = (I3D::Model& Mdl)
	{
		RS = Mdl.RS;
		strcpy(StandardTexture, Mdl.StandardTexture);
	}*/

public:
	TreeModel(void) {}

	/*TreeModel(I3D::Model *Mdl, LPDIRECT3DDEVICE8 D3DDevice)
	{
		*this = *Mdl;
		RS.CreateVBuf(D3DDevice);
		RS.CreateIBuf(D3DDevice);
	}*/

	static I3D::Model *GetModel(I3D::D3DStruct *DS, char *Name)
	{
		using namespace I3D;

		for(int i = 0; i < LoadedModels.Count(); i++)
			if(!strcmpi(Name, LoadedModels[i].Name))
				return LoadedModels[i].Mdl;
		Model *NewModel = new TreeModel();
		NewModel->Create(DS, Name);
		LoadedModels[LoadedModels.Count()] = LoadedModel(Name, NewModel);
		return NewModel;

		/*using namespace I3D;
		static TreeModel *TMdl = 0;
		if(!TMdl)
		{
			Model *NewModel = Model::GetModel(DS, Name);
			TMdl = new TreeModel(NewModel, DS->D3DDevice);
		}
		return TMdl;*/
	}

	virtual void PreRender(I3D::D3DStruct *DS);
	virtual void PostRender(I3D::D3DStruct *DS);
};

}

#endif
